"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));

require("jest-styled-components");

var _theme = require("../../utils/theme");

var _Alert = _interopRequireDefault(require("./Alert"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var c = _reactTestRenderer.default.create;
describe('<Alert />', function () {
  describe('snapshots', function () {
    it('renders success', function () {
      var tree = c((0, _theme.withTheme)(_react.default.createElement(_Alert.default, {
        type: "success"
      }, "Success"))).toJSON();
      expect(tree).toMatchSnapshot();
    });
    it('renders warning', function () {
      var tree = c((0, _theme.withTheme)(_react.default.createElement(_Alert.default, {
        type: "warning"
      }, "Warning"))).toJSON();
      expect(tree).toMatchSnapshot();
    });
    it('renders error', function () {
      var tree = c((0, _theme.withTheme)(_react.default.createElement(_Alert.default, {
        type: "error"
      }, "Error"))).toJSON();
      expect(tree).toMatchSnapshot();
    });
    it('renders default', function () {
      var tree = c((0, _theme.withTheme)(_react.default.createElement(_Alert.default, null, "Default"))).toJSON();
      expect(tree).toMatchSnapshot();
    });
    it('renders title if provided', function () {
      var tree = c((0, _theme.withTheme)(_react.default.createElement(_Alert.default, {
        title: "title"
      }, "Default"))).toJSON();
      expect(tree).toMatchSnapshot();
    });
    it('renders icon if provided', function () {
      var tree = c((0, _theme.withTheme)(_react.default.createElement(_Alert.default, {
        icon: "warning"
      }, "Default"))).toJSON();
      expect(tree).toMatchSnapshot();
    });
  });
  it('closes when the "x" is clicked', function () {
    var spy = jest.fn();
    var alert = (0, _enzyme.mount)((0, _theme.withTheme)(_react.default.createElement(_Alert.default, {
      onClose: spy
    }, "My alert")));
    alert.find('.fa-remove').first().simulate('click');
    expect(spy.mock.calls.length).toEqual(1);
  });
});