"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _theme = require("../../utils/theme");

var _ = _interopRequireDefault(require("."));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

document.execCommand = function () {};

document.getSelection = function () {
  return {
    toString: function toString() {
      return '';
    }
  };
};

describe('<Code />', function () {
  var props;
  var wrapper;
  var onCopy;
  beforeEach(function () {
    onCopy = jest.fn();
    props = {
      onCopy: onCopy
    };
    wrapper = (0, _enzyme.shallow)((0, _theme.withTheme)(_react.default.createElement(_.default, props, "such code much programming")));
  });
  it('should call onCopy when the button is clicked', function () {
    wrapper = (0, _enzyme.mount)((0, _theme.withTheme)(_react.default.createElement(_.default, props, "such code much programming")));
    expect(onCopy).not.toHaveBeenCalled();
    wrapper.find('Code__CopyNotice').simulate('click');
    expect(onCopy).toHaveBeenCalledTimes(1);
  });
  it('should render correctly', function () {
    expect(wrapper.dive()).toMatchSnapshot();
  });
  it('should render multi line string correctly with multiCommand=true', function () {
    wrapper = (0, _enzyme.shallow)((0, _theme.withTheme)(_react.default.createElement(_.default, {
      multiCommand: true
    }, "\nsudo curl -l git.io/scope -o /usr/local/bin/scope\nsudo chmod a+x /usr/local/bin/scope\nscope launch https://yjsjsubdx1h8un1f858gp7to8d51zdre@frontend.dev.weave.works\n          ")));
    expect(wrapper.dive()).toMatchSnapshot();
  });
  it('should render multi line function correctly with multiCommand=true', function () {
    wrapper = (0, _enzyme.shallow)((0, _theme.withTheme)(_react.default.createElement(_.default, {
      multiCommand: true
    }, function () {
      return "\nsudo curl -l git.io/scope -o /usr/local/bin/scope\nsudo chmod a+x /usr/local/bin/scope\nscope launch https://yjsjsubdx1h8un1f858gp7to8d51zdre@frontend.dev.weave.works\n      ";
    })));
    expect(wrapper.dive()).toMatchSnapshot();
  });
  it('should render multi line jsx correctly with multiCommand=true', function () {
    wrapper = (0, _enzyme.shallow)((0, _theme.withTheme)(_react.default.createElement(_.default, {
      multiCommand: true
    }, _react.default.createElement("div", null, "sudo curl -L git.io/scope -o /usr/local/bin/scope"), _react.default.createElement("div", null, "sudo chmod a+x /usr/local/bin/scope"), _react.default.createElement("div", null, "scope launch ", _react.default.createElement("wbr", null), "https://yjsjsubdx1h8un1f858gp7to8d51zdre@frontend.dev.weave.works"))));
    expect(wrapper.dive()).toMatchSnapshot();
  });
});