"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _example = require("../../utils/example");

var _Button = _interopRequireDefault(require("../Button"));

var _ = _interopRequireDefault(require("."));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DialogExample =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DialogExample, _React$Component);

  function DialogExample() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, DialogExample);

    for (var _len = arguments.length, _args = new Array(_len), _key = 0; _key < _len; _key++) {
      _args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(DialogExample)).call.apply(_getPrototypeOf2, [this].concat(_args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      normalButtonActive: false,
      otherButtonActive: false,
      emptyButtonActive: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleDialogActivate", function (type, args) {
      var key = "".concat(type, "ButtonActive");

      if (_this.state[key]) {
        _this.props.clickHandler('onActionClick', args);
      }

      _this.setState(_defineProperty({}, key, !_this.state[key]));
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleClose", function () {
      _this.setState({
        normalButtonActive: false,
        otherButtonActive: false,
        emptyButtonActive: false,
        hideCloseButtonActive: false
      });
    });

    return _this;
  }

  _createClass(DialogExample, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var Action1 = function Action1() {
        return _react.default.createElement(_Button.default, {
          onClick: _this2.handleDialogActivate.bind(_this2, 'other', 'Action 1 Payload')
        }, "Action 1");
      };

      var Action2 = function Action2() {
        return _react.default.createElement(_Button.default, {
          onClick: _this2.handleDialogActivate.bind(_this2, 'other', 'Action 2 Payload')
        }, "Action 2");
      };

      return _react.default.createElement("div", null, _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Normal dialog with overlay"), _react.default.createElement(_.default, {
        active: this.state.normalButtonActive,
        actions: ['Submit', 'Cancel'],
        onClose: this.handleClose,
        onActionClick: this.handleClose
      }, _react.default.createElement("p", null, "Here is some content that I would like to display")), _react.default.createElement(_Button.default, {
        onClick: this.handleDialogActivate.bind(this, 'normal'),
        text: "Dialog"
      })), _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Dialog with no close icon"), _react.default.createElement(_Button.default, {
        onClick: this.handleDialogActivate.bind(this, 'hideClose'),
        text: "No Close Icon"
      }), _react.default.createElement(_.default, {
        hideClose: true,
        active: this.state.hideCloseButtonActive,
        onClose: this.handleClose,
        title: "Dialog without cross icon",
        width: "400px"
      }, _react.default.createElement("p", null, "No close icon top right "))), _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Dialog with pre-created actions"), _react.default.createElement(_Button.default, {
        onClick: this.handleDialogActivate.bind(this, 'other'),
        text: "Custom Actions"
      }), _react.default.createElement(_.default, {
        active: this.state.otherButtonActive,
        actions: [_react.default.createElement(Action1, null), _react.default.createElement(Action2, null)],
        onClose: this.handleClose,
        title: "Dialog with title",
        width: "400px"
      }, _react.default.createElement("p", null, "This one has custom actions"))), _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Dialog with no actions actions"), _react.default.createElement(_Button.default, {
        onClick: this.handleDialogActivate.bind(this, 'empty'),
        text: "No Actions"
      }), _react.default.createElement(_.default, {
        active: this.state.emptyButtonActive,
        onClose: this.handleClose,
        title: "Dialog with title",
        width: "300px"
      }, _react.default.createElement("span", null, "This one has no actions"))));
    }
  }]);

  return DialogExample;
}(_react.default.Component);

exports.default = DialogExample;