"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _example = require("../../utils/example");

var _Grid = require("../Grid");

var _Button = _interopRequireDefault(require("../Button"));

var _ = _interopRequireDefault(require("."));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var generateItems = function generateItems() {
  var hash = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return [{
    value: "first-thing".concat(hash),
    label: 'First Thing'
  }, {
    value: "second-thing".concat(hash),
    label: 'Second Thing'
  }, {
    value: "third-thing".concat(hash),
    label: 'Super long thing, this should get truncated'
  }];
};

var items = generateItems();
var groups = [[{
  value: 'a-first',
  label: 'A: First Thing'
}, {
  value: 'a-second',
  label: 'A: Second Thing'
}], [{
  value: 'b-first',
  label: 'B: First Thing'
}, {
  value: 'b-second',
  label: 'B: Second Thing'
}]];
var divided = [{
  value: 'c-first',
  label: 'C: First Thing'
}, null, {
  value: 'd-first',
  label: 'D: First Thing'
}];

var DropdownButton = function DropdownButton(_ref) {
  var onClick = _ref.onClick;
  return _react.default.createElement(_Button.default, {
    onClick: onClick
  }, "More actions ", _react.default.createElement("i", {
    className: "fa fa-caret-down"
  }));
};

var DropdownExample =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DropdownExample, _React$Component);

  function DropdownExample() {
    var _this;

    _classCallCheck(this, DropdownExample);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DropdownExample).call(this));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleChange", function (ev, value) {
      _this.setState(function () {
        return {
          selected: value
        };
      });
    });

    _this.state = {
      selected: null
    };
    return _this;
  }

  _createClass(DropdownExample, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_Grid.Grid, null, _react.default.createElement(_Grid.GridRow, null, _react.default.createElement(_Grid.GridColumn, {
        span: 6
      }, _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Default dropdown"), _react.default.createElement(_.default, {
        items: _toConsumableArray(generateItems('a')).concat(_toConsumableArray(generateItems('b')), _toConsumableArray(generateItems('c')), _toConsumableArray(generateItems('d'))),
        value: this.state.selected,
        onChange: this.handleChange
      }))), _react.default.createElement(_Grid.GridColumn, {
        span: 6
      }, _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Grouped items (passed as subarrays)"), _react.default.createElement(_.default, {
        items: groups,
        value: this.state.selected,
        onChange: this.handleChange
      })))), _react.default.createElement(_Grid.GridRow, null, _react.default.createElement(_Grid.GridColumn, {
        span: 6
      }, _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Grouped items (with null as dividers)"), _react.default.createElement(_.default, {
        items: divided,
        value: this.state.selected,
        onChange: this.handleChange
      }))), _react.default.createElement(_Grid.GridColumn, {
        span: 6
      }, _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "With placeholder"), _react.default.createElement(_.default, {
        items: items,
        placeholder: "Select an item",
        value: this.state.selected,
        onChange: this.handleChange
      })))), _react.default.createElement(_Grid.GridRow, null, _react.default.createElement(_Grid.GridColumn, {
        span: 6
      }, _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "With ", _react.default.createElement("code", null, "Button"), " component"), _react.default.createElement(_.default, {
        withComponent: DropdownButton,
        items: divided,
        value: this.state.selected,
        onChange: this.handleChange
      })))), _react.default.createElement("div", {
        style: {
          height: '50px'
        }
      }));
    }
  }]);

  return DropdownExample;
}(_react.default.Component);

exports.default = DropdownExample;