"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _sample2 = _interopRequireDefault(require("lodash/sample"));

var _times2 = _interopRequireDefault(require("lodash/times"));

var _keys2 = _interopRequireDefault(require("lodash/keys"));

var _react = _interopRequireDefault(require("react"));

var _faker = _interopRequireDefault(require("faker"));

var _d3Format = require("d3-format");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _example = require("../../utils/example");

var _Search = _interopRequireDefault(require("../Search"));

var _GraphNodeStatic = require("./_GraphNodeStatic");

var _GraphNode = _interopRequireDefault(require("./GraphNode"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var nodeTypes = (0, _keys2.default)(_GraphNodeStatic.shapes);

var colorFunction = function colorFunction(label) {
  return "hsl(".concat((label.charCodeAt(0) - 97) * 10, ", 50%, 65%)");
};

var GraphNodeContainer = function GraphNodeContainer(_ref) {
  var size = _ref.size,
      children = _ref.children;
  return _react.default.createElement("svg", {
    width: "".concat(2.5 * size, "px"),
    height: "".concat(3 * size, "px")
  }, _react.default.createElement("g", {
    style: {
      transform: "translate(".concat(size * 1.2, "px, ").concat(size * 1.6, "px)")
    }
  }, children));
};

var CheckBox = _styledComponents.default.input.attrs({
  type: 'checkbox'
}).withConfig({
  displayName: "example__CheckBox",
  componentId: "sc-15camu2-0"
})(["margin-right:10px;margin-bottom:30px;"]);

var TextInput = _styledComponents.default.input.attrs({
  type: 'input'
}).withConfig({
  displayName: "example__TextInput",
  componentId: "sc-15camu2-1"
})(["text-align:right;margin-left:30px;margin-right:5px;width:40px;"]);

var GraphNodeExample =
/*#__PURE__*/
function (_React$Component) {
  _inherits(GraphNodeExample, _React$Component);

  function GraphNodeExample() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, GraphNodeExample);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(GraphNodeExample)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      availableShapes: _toConsumableArray(nodeTypes.map(function (shape) {
        return {
          shape: shape,
          label: shape,
          key: _faker.default.lorem.slug()
        };
      })).concat([{
        tag: 'camera',
        shape: 'cylinder',
        label: 'cylinder + camera',
        key: _faker.default.lorem.slug()
      }, {
        tag: 'camera',
        shape: 'dottedcylinder',
        label: 'dottedcylinder + camera',
        key: _faker.default.lorem.slug()
      }]),
      stackedShape: nodeTypes.map(function (shape) {
        return {
          shape: shape,
          key: _faker.default.lorem.slug()
        };
      }),
      randomSearchableNodes: (0, _times2.default)(20, function () {
        return {
          shape: (0, _sample2.default)(nodeTypes),
          key: _faker.default.lorem.slug(),
          label: _faker.default.lorem.word(),
          labelMinor: "ip-".concat(_faker.default.internet.ip().split('.').join('-'))
        };
      }),
      randomSvgNodes: (0, _times2.default)(20, function () {
        return {
          shape: (0, _sample2.default)(nodeTypes),
          key: _faker.default.lorem.slug(),
          label: _faker.default.lorem.word(),
          labelMinor: "ip-".concat(_faker.default.internet.ip().split('.').join('-'))
        };
      }),
      metricNodes: [0, 0.01, 0.1, 0.5, 0.9, 0.99, 1].map(function (value) {
        return {
          key: _faker.default.lorem.slug(),
          metricFormattedValue: (0, _d3Format.format)('.0%')(value),
          metricNumericValue: value
        };
      }),
      animatedNode: {
        size: 50,
        x: 50,
        y: 50
      },
      size: 65,
      contrastMode: false,
      query: '',
      pinnedTerms: [],
      searchTerms: []
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleContrastModeChange", function () {
      _this.setState({
        contrastMode: !_this.state.contrastMode
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleSizeChange", function (ev) {
      _this.setState({
        size: Number(ev.target.value)
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleMouseEnter", function (hoveredNodeId) {
      _this.setState({
        hoveredNodeId: hoveredNodeId
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleMouseLeave", function () {
      _this.setState({
        hoveredNodeId: null
      });
    });

    return _this;
  }

  _createClass(GraphNodeExample, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.timer = setInterval(function () {
        _this2.setState({
          animatedNode: {
            size: _faker.default.random.number({
              min: 30,
              max: 90
            }),
            x: _faker.default.random.number({
              min: 100,
              max: 700
            }),
            y: _faker.default.random.number({
              min: 100,
              max: 500
            })
          }
        });
      }, 1000);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearInterval(this.timer);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return _react.default.createElement("div", null, _react.default.createElement(CheckBox, {
        checked: this.state.contrastMode,
        onChange: this.handleContrastModeChange
      }), "Contrast Mode", _react.default.createElement(TextInput, {
        value: this.state.size,
        onChange: this.handleSizeChange
      }), "px - node size", _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Available Shapes"), this.state.availableShapes.map(function (node) {
        return _react.default.createElement(GraphNodeContainer, {
          size: _this3.state.size,
          key: node.key
        }, _react.default.createElement(_GraphNode.default, {
          id: node.key,
          shape: node.shape,
          tag: node.tag,
          label: node.label,
          size: _this3.state.size,
          contrastMode: _this3.state.contrastMode,
          highlighted: node.key === _this3.state.hoveredNodeId,
          onMouseEnter: _this3.handleMouseEnter,
          onMouseLeave: _this3.handleMouseLeave
        }));
      })), _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Stacked Shapes"), this.state.stackedShape.map(function (node) {
        return _react.default.createElement(GraphNodeContainer, {
          size: _this3.state.size,
          key: node.key
        }, _react.default.createElement(_GraphNode.default, {
          stacked: true,
          id: node.key,
          shape: node.shape,
          label: node.shape,
          size: _this3.state.size,
          contrastMode: _this3.state.contrastMode,
          highlighted: node.key === _this3.state.hoveredNodeId,
          onMouseEnter: _this3.handleMouseEnter,
          onMouseLeave: _this3.handleMouseLeave
        }));
      })), _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Random Nodes (standard format with search matches)"), _react.default.createElement(_Search.default, {
        query: this.state.query,
        pinnedTerms: this.state.pinnedTerms,
        onChange: function onChange(query, pinnedTerms) {
          return _this3.setState({
            query: query,
            pinnedTerms: pinnedTerms,
            searchTerms: _toConsumableArray(pinnedTerms).concat([query])
          });
        }
      }), this.state.randomSearchableNodes.map(function (node) {
        return _react.default.createElement(GraphNodeContainer, {
          big: true,
          size: _this3.state.size,
          key: node.key
        }, _react.default.createElement(_GraphNode.default, {
          id: node.key,
          shape: node.shape,
          label: node.label,
          labelMinor: node.labelMinor,
          color: colorFunction(node.label),
          searchTerms: _this3.state.searchTerms,
          size: _this3.state.size,
          contrastMode: _this3.state.contrastMode,
          highlighted: node.key === _this3.state.hoveredNodeId,
          onMouseEnter: _this3.handleMouseEnter,
          onMouseLeave: _this3.handleMouseLeave
        }));
      })), _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Random Nodes (exporting format)"), this.state.randomSvgNodes.map(function (node) {
        return _react.default.createElement(GraphNodeContainer, {
          size: _this3.state.size,
          key: node.key
        }, _react.default.createElement(_GraphNode.default, {
          id: node.key,
          shape: node.shape,
          label: node.label,
          labelMinor: node.labelMinor,
          color: colorFunction(node.label),
          size: _this3.state.size,
          contrastMode: _this3.state.contrastMode,
          highlighted: node.key === _this3.state.hoveredNodeId,
          onMouseEnter: _this3.handleMouseEnter,
          onMouseLeave: _this3.handleMouseLeave,
          forceSvg: true
        }));
      })), _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Metric Fills"), this.state.metricNodes.map(function (node) {
        return _react.default.createElement(GraphNodeContainer, {
          size: _this3.state.size,
          key: node.key
        }, _react.default.createElement(_GraphNode.default, {
          id: node.key,
          shape: "pentagon",
          label: "node",
          metricFormattedValue: node.metricFormattedValue,
          metricNumericValue: node.metricNumericValue,
          size: _this3.state.size,
          contrastMode: _this3.state.contrastMode,
          highlighted: node.key === _this3.state.hoveredNodeId,
          onMouseEnter: _this3.handleMouseEnter,
          onMouseLeave: _this3.handleMouseLeave
        }));
      })), _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Animated Node"), _react.default.createElement("svg", {
        width: "800px",
        height: "600px"
      }, _react.default.createElement(_GraphNode.default, _extends({
        id: "animated-node",
        shape: "pentagon",
        label: "node",
        isAnimated: true,
        contrastMode: this.state.contrastMode
      }, this.state.animatedNode)))));
    }
  }]);

  return GraphNodeExample;
}(_react.default.Component);

exports.default = GraphNodeExample;