"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _times2 = _interopRequireDefault(require("lodash/times"));

var _range2 = _interopRequireDefault(require("lodash/range"));

var _compact2 = _interopRequireDefault(require("lodash/compact"));

var _react = _interopRequireDefault(require("react"));

var _faker = _interopRequireDefault(require("faker"));

var _moment = _interopRequireDefault(require("moment"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _example = require("../../utils/example");

var _ = _interopRequireDefault(require("."));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var InlineBlock = _styledComponents.default.div.withConfig({
  displayName: "example__InlineBlock",
  componentId: "kqo0yo-0"
})(["display:inline-block;margin-right:5%;width:45%;"]);

function generateRandomMultiSeries(_ref, key, count) {
  var startTime = _ref.startTime,
      endTime = _ref.endTime,
      stepDuration = _ref.stepDuration;
  return (0, _times2.default)(count, function () {
    return {
      metric: _defineProperty({}, key, _faker.default.lorem.slug()),
      values: (0, _range2.default)(startTime, endTime + 1e-6, stepDuration).map(function (time) {
        return [time, _faker.default.random.number({
          min: 10,
          max: 20
        })];
      })
    };
  });
}

function generateCorrelatedMultiSeries(_ref2, key, count) {
  var startTime = _ref2.startTime,
      endTime = _ref2.endTime,
      stepDuration = _ref2.stepDuration;
  return (0, _times2.default)(count, function (index) {
    return {
      metric: _defineProperty({}, key, ['aaa', 'bbb', 'bbb', 'ccc', 'ddd'][index]),
      values: (0, _range2.default)(startTime, endTime + 1e-6, stepDuration).map(function (time) {
        return [time, _faker.default.random.number({
          min: 10,
          max: 20
        })];
      })
    };
  });
}

function generateDeployments(_ref3, count) {
  var startTime = _ref3.startTime,
      endTime = _ref3.endTime;
  return (0, _times2.default)(count, function () {
    return {
      Stamp: _moment.default.unix(_faker.default.random.number({
        min: startTime,
        max: endTime
      })),
      Data: (0, _compact2.default)(["Commit: ".concat(_faker.default.lorem.word()), Math.random() < 0.5 && _faker.default.lorem.slug(), Math.random() < 0.5 && _faker.default.lorem.slug(), Math.random() < 0.5 && _faker.default.lorem.slug()]).join(', ')
    };
  });
}

var PrometheusGraphExample =
/*#__PURE__*/
function (_React$Component) {
  _inherits(PrometheusGraphExample, _React$Component);

  function PrometheusGraphExample() {
    var _this;

    _classCallCheck(this, PrometheusGraphExample);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PrometheusGraphExample).call(this));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "changeLegendSelection", function (selectedCorrelatedKeys) {
      _this.setState({
        selectedCorrelatedKeys: selectedCorrelatedKeys
      });
    });

    _this.state = {
      selectedCorrelatedKeys: [],
      startTime: (0, _moment.default)('2018-02-05T11:24:14Z').unix(),
      endTime: (0, _moment.default)('2018-02-05T11:54:14Z').unix(),
      stepDuration: 9,
      loading: true
    };
    _this.state.multiSeriesJobs = generateRandomMultiSeries(_this.state, 'job', 7);
    _this.state.multiSeriesServices = generateRandomMultiSeries(_this.state, 'namespace', 4);
    _this.state.multiSeriesCorrelatedA = generateCorrelatedMultiSeries(_this.state, 'namespace', 5);
    _this.state.multiSeriesCorrelatedB = generateCorrelatedMultiSeries(_this.state, 'namespace', 5);
    _this.state.deployments = generateDeployments(_this.state, 6);
    return _this;
  }

  _createClass(PrometheusGraphExample, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.timer = setInterval(function () {
        _this2.setState({
          loading: false
        });

        setTimeout(function () {
          _this2.setState({
            loading: true
          });
        }, 2500);
      }, 5000);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearInterval(this.timer);
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", null, _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Simple Prometheus graph"), _react.default.createElement(_.default, {
        showStacked: true,
        multiSeries: this.state.multiSeriesJobs,
        stepDurationSec: this.state.stepDuration,
        startTimeSec: this.state.startTime,
        endTimeSec: this.state.endTime,
        getSeriesNameParts: function getSeriesNameParts(_ref4) {
          var metric = _ref4.metric;
          return [JSON.stringify(metric), 'sum(rate(prometheus_remote_storage_succeeded_samples_total{}[5m])) by (queue)'];
        }
      }), _react.default.createElement(_example.Info, null, "Namespaces with deployments"), _react.default.createElement(_.default, {
        showStacked: true,
        multiSeries: this.state.multiSeriesServices,
        stepDurationSec: this.state.stepDuration,
        startTimeSec: this.state.startTime,
        endTimeSec: this.state.endTime,
        deployments: this.state.deployments
      }), _react.default.createElement(_example.Info, null, "Reloading graph"), _react.default.createElement(_.default, {
        showStacked: true,
        loading: this.state.loading,
        multiSeries: this.state.multiSeriesServices,
        stepDurationSec: this.state.stepDuration,
        startTimeSec: this.state.startTime,
        endTimeSec: this.state.endTime,
        deployments: this.state.deployments
      }), _react.default.createElement(_example.Info, null, "Correlated graphs"), _react.default.createElement(InlineBlock, null, _react.default.createElement(_.default, {
        showStacked: true,
        selectedLegendKeys: this.state.selectedCorrelatedKeys,
        onChangeLegendSelection: this.changeLegendSelection,
        multiSeries: this.state.multiSeriesCorrelatedA,
        stepDurationSec: this.state.stepDuration,
        startTimeSec: this.state.startTime,
        endTimeSec: this.state.endTime,
        deployments: this.state.deployments
      })), _react.default.createElement(InlineBlock, null, _react.default.createElement(_.default, {
        showStacked: true,
        selectedLegendKeys: this.state.selectedCorrelatedKeys,
        onChangeLegendSelection: this.changeLegendSelection,
        multiSeries: this.state.multiSeriesCorrelatedB,
        stepDurationSec: this.state.stepDuration,
        startTimeSec: this.state.startTime,
        endTimeSec: this.state.endTime,
        deployments: this.state.deployments
      })), _react.default.createElement(_example.Info, null, "Error with no data"), _react.default.createElement(_.default, {
        showStacked: true,
        multiSeries: [],
        error: "No datapoints found. Maybe the metric does not exist?",
        loading: this.state.loading,
        stepDurationSec: this.state.stepDuration,
        startTimeSec: this.state.startTime,
        endTimeSec: this.state.endTime,
        deployments: this.state.deployments
      }), _react.default.createElement(_example.Info, null, "Error with data"), _react.default.createElement(_.default, {
        showStacked: true,
        multiSeries: this.state.multiSeriesServices,
        error: "Hmm... something with the metrics looks wrong",
        loading: this.state.loading,
        stepDurationSec: this.state.stepDuration,
        startTimeSec: this.state.startTime,
        endTimeSec: this.state.endTime
      })));
    }
  }]);

  return PrometheusGraphExample;
}(_react.default.Component);

exports.default = PrometheusGraphExample;