"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));

require("jest-styled-components");

var _theme = require("../../utils/theme");

var _TabSelect = _interopRequireDefault(require("./TabSelect"));

var _Tab = _interopRequireDefault(require("./Tab"));

var _TabButton = _interopRequireDefault(require("./_TabButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<Tab Select />', function () {
  describe('snapshots', function () {
    it('renders', function () {
      var tree = _reactTestRenderer.default.create((0, _theme.withTheme)(_react.default.createElement(_TabSelect.default, null, _react.default.createElement(_Tab.default, {
        label: "A",
        name: "a"
      }, "Tab A"), _react.default.createElement(_Tab.default, {
        label: "B",
        name: "b"
      }, "Tab B"), _react.default.createElement(_Tab.default, {
        label: "C",
        name: "c"
      }, "Tab C")))).toJSON();

      expect(tree).toMatchSnapshot();
    });
    it('renders with a selectedTab', function () {
      var tree = _reactTestRenderer.default.create((0, _theme.withTheme)(_react.default.createElement(_TabSelect.default, {
        selectedTab: "b"
      }, _react.default.createElement(_Tab.default, {
        label: "A",
        name: "a"
      }, "Tab A"), _react.default.createElement(_Tab.default, {
        label: "B",
        name: "b"
      }, "Tab B"), _react.default.createElement(_Tab.default, {
        label: "C",
        name: "c"
      }, "Tab C")))).toJSON();

      expect(tree).toMatchSnapshot();
    });
  });
  it('changes tabs on click', function () {
    var tabs = (0, _enzyme.mount)((0, _theme.withTheme)(_react.default.createElement(_TabSelect.default, null, _react.default.createElement(_Tab.default, {
      label: "A",
      name: "a"
    }, "Tab A"), _react.default.createElement(_Tab.default, {
      label: "B",
      name: "b"
    }, "Tab B"), _react.default.createElement(_Tab.default, {
      label: "C",
      name: "c"
    }, "Tab C"))));
    tabs.find(_TabButton.default).at(1).simulate('click');
    expect(tabs.find(_Tab.default).text()).toEqual('Tab B');
  });
});