"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _times2 = _interopRequireDefault(require("lodash/times"));

var _compact2 = _interopRequireDefault(require("lodash/compact"));

var _react = _interopRequireDefault(require("react"));

var _faker = _interopRequireDefault(require("faker"));

var _moment = _interopRequireDefault(require("moment"));

var _Text = _interopRequireDefault(require("../Text"));

var _example = require("../../utils/example");

var _ = _interopRequireDefault(require("."));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function generateDeployments(_ref, count) {
  var startTime = _ref.startTime,
      endTime = _ref.endTime;
  return (0, _times2.default)(count, function () {
    return {
      Stamp: _moment.default.unix(_faker.default.random.number({
        min: startTime,
        max: endTime
      })),
      Data: (0, _compact2.default)(["Commit: ".concat(_faker.default.lorem.word()), Math.random() < 0.5 && _faker.default.lorem.slug(), Math.random() < 0.5 && _faker.default.lorem.slug(), Math.random() < 0.5 && _faker.default.lorem.slug()]).join(', ')
    };
  });
}

var TimeTravelExample =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TimeTravelExample, _React$Component);

  function TimeTravelExample(props) {
    var _this;

    _classCallCheck(this, TimeTravelExample);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TimeTravelExample).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleChangeTimestamp1", function (timestamp1) {
      _this.setState({
        timestamp1: timestamp1
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleChangeTimestamp2", function (timestamp2) {
      _this.setState({
        timestamp2: timestamp2,
        isLoading2: true
      }); // Show loading indicator for 5 seconds after every timestamp change..


      setTimeout(function () {
        _this.setState({
          isLoading2: false
        });
      }, 5000);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleChangeTimestamp3", function (timestamp3) {
      _this.setState({
        timestamp3: timestamp3
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleChangeLiveMode3", function (showingLive3) {
      _this.setState({
        showingLive3: showingLive3
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleChangeRange3", function (rangeMs3) {
      _this.setState({
        rangeMs3: rangeMs3
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleUpdateVisibleRange", function (_ref2) {
      var startAt = _ref2.startAt,
          endAt = _ref2.endAt;

      _this.setState({
        visibleStartAt: startAt,
        visibleEndAt: endAt
      });
    });

    _this.state = {
      timestamp1: (0, _moment.default)().utc().format(),
      timestamp2: (0, _moment.default)().utc().format(),
      timestamp3: (0, _moment.default)().utc().format(),
      isLoading2: false,
      showingLive3: true,
      rangeMs3: 3600000,
      visibleStartAt: null,
      visibleEndAt: null,
      deployments: generateDeployments({
        startTime: (0, _moment.default)().subtract(1, 'month').unix(),
        endTime: (0, _moment.default)().unix()
      }, 500)
    };
    return _this;
  }

  _createClass(TimeTravelExample, [{
    key: "render",
    value: function render() {
      return _react.default.createElement("div", null, _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Simple timestamp selector"), _react.default.createElement(_.default, {
        timestamp: this.state.timestamp1,
        onChangeTimestamp: this.handleChangeTimestamp1,
        onUpdateVisibleRange: this.handleUpdateVisibleRange
      })), _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "With deployments"), _react.default.createElement(_.default, {
        isLoading: this.state.isLoading2,
        timestamp: this.state.timestamp2,
        onChangeTimestamp: this.handleChangeTimestamp2,
        onUpdateVisibleRange: this.handleUpdateVisibleRange,
        deployments: this.state.deployments
      })), _react.default.createElement(_example.Example, null, _react.default.createElement(_example.Info, null, "Range selector with live mode support"), _react.default.createElement(_.default, {
        timestamp: this.state.timestamp3,
        onChangeTimestamp: this.handleChangeTimestamp3,
        hasLiveMode: true,
        showingLive: this.state.showingLive3,
        onChangeLiveMode: this.handleChangeLiveMode3,
        hasRangeSelector: true,
        rangeMs: this.state.rangeMs3,
        onChangeRange: this.handleChangeRange3,
        onUpdateVisibleRange: this.handleUpdateVisibleRange
      })), _react.default.createElement("hr", null), _react.default.createElement(_Text.default, {
        small: true
      }, "Visible range: ", this.state.visibleStartAt, " - ", this.state.visibleEndAt));
    }
  }]);

  return TimeTravelExample;
}(_react.default.Component);

exports.default = TimeTravelExample;